import {
  WorkCard,
  InputParameterManager,
  OutputParameterManager,
  GenericParameter,
  WorkCardRegister,
  IDataManager
} from "@noah-i/core";

@WorkCardRegister({
  name: "TestCard",
  version: "0.0.1",
  uuid: "3667787c-86a0-4ad0-b827-3263f1d18198",
  category: "测试功能"
})
class TestCard extends WorkCard {
  registerInputParameter(pm: InputParameterManager): void {
    pm.registerParam(new GenericParameter<string>("in1", "string", "", false));
  }
  registerOutputParameter(pm: OutputParameterManager): void {
    pm.registerParam(new GenericParameter<string>("out1", "string", "", false));
  }
  process(dm: IDataManager) {
    dm.setData(0, this.getRandomData());
  }
  getRandomData() {
    const res: number[][] = [];
    const colCnt = Math.floor(15 * Math.random());
    const rowCnt = Math.floor(12 * Math.random());
    while (res.length < colCnt) {
      const row: number[] = [];
      while (row.length < rowCnt) {
        row.push(Math.floor(100 * Math.random()));
      }
      res.push(row);
    }
    return res;
  }
}

export { TestCard };
